from raidtrackertg2.model import DBSession, metadata
from raidtrackertg2.model.item import Item
from raidtrackertg2.model.player import Player
from raidtrackertg2.model.raid import Raid
from raidtrackertg2.model.loot import Loot
from raidtrackertg2.model.guildrank import GuildRank
from raidtrackertg2.model.professions import Professions

from sqlalchemy import create_engine
import transaction
from datetime import datetime

import urllib2
from urllib import urlencode, quote
import xml.dom.minidom
import time

# Prepare the database connection
engine = create_engine("sqlite:///devdata.db", echo=True)
DBSession.configure(bind=engine)

# Create the tables
metadata.drop_all(engine)
metadata.create_all(engine)

# GLA Guild Rankings
DBSession.add_all([
    GuildRank(-1, 'N/A', 'Default'),
    GuildRank(0, 'GuildMaster', "Cadin's level 1 Alt"),
    GuildRank(1, 'GM', 'Our actual chars that are GMs'),
    GuildRank(2, 'Officer', None),
    GuildRank(3, 'Officer Alt', None),
    GuildRank(4, 'Core Raider', None),
    GuildRank(5, 'Raider', None),
    GuildRank(6, 'Raiding Recruit', None),
    GuildRank(7, 'Non-Raider', None),
    GuildRank(8, 'Alt', None),
    GuildRank(9, 'NTAC', '(if we have this)')
])

#DBSession.add_all([
#    ProfessionLookup('Unknown', 0),          # 1
#    ProfessionLookup('Alchemy', 1),          # 2
#    ProfessionLookup('Blacksmithing', 1),    # 3
#    ProfessionLookup('Cooking', 2),          # 4
#    ProfessionLookup('Enchanting', 1),       # 5
#    ProfessionLookup('Engineering', 1),      # 6
#    ProfessionLookup('First Aid', 2),        # 7
#    ProfessionLookup('Fishing', 2),          # 8
#    ProfessionLookup('Herbalism', 1),        # 9
#    ProfessionLookup('Jewelcrafting', 1),    # 10
#    ProfessionLookup('Leatherworking', 1),   # 11
#    ProfessionLookup('Mining', 1),           # 12
#    ProfessionLookup('Tailoring', 1),        # 13
#    ProfessionLookup('Skining', 1),          # 14
#    ProfessionLookup('Inscription', 1),      # 15
#])

# Create a page object and set some data
item = Item("Great Cosmic Essence", "Epic", 34055, 0, 0, 0, 0, 0, 2087375664, 80)
item2 = Item("Lesser Cosmic Essence", "Epic", 34155, 0, 0, 0, 0, 0, 2085325364, 80)

raid = Raid(1, datetime.today(), 'Naxxramas', 'Heroic')
DBSession.add(raid)

raid2 = Raid(2, datetime.today(), 'Ironforge', 'Heroic')
DBSession.add(raid2)

raid3 = Raid(3, datetime.today(), 'The Eye of Eternity', 'Heroic')
DBSession.add(raid3)

url = urllib2.build_opener()
url.addheaders = [
    ('user-agent',
     'Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10.5; en-US; rv:1.9.0.3) Gecko/2008092414 Firefox/3.0.6'), 
]

req = urllib2.Request('http://www.wowarmory.com/guild-info.xml?r=Executus&n=GLA&p=1')
dom = xml.dom.minidom.parseString(url.open(req).read())

for node in dom.getElementsByTagName('character'):
    name = node.attributes['name'].value
    race = node.attributes['race'].value
    guild = 'GLA'
    sex = node.attributes['gender'].value
    the_class = node.attributes['class'].value
    level = node.attributes['level'].value
    guild_rank = node.attributes['rank'].value
    achievement_points = node.attributes['achPoints'].value
    player_url = node.attributes['url'].value
    guildie = Player(name, race, guild, sex, the_class, level, guild_rank, achievement_points)
    print name.encode('iso-8859-1')

    req2 = urllib2.Request('http://www.wowarmory.com/character-sheet.xml?'+player_url)
    dom2 = xml.dom.minidom.parseString(url.open(req2).read())
    for node2 in dom2.getElementsByTagName('skill'):
        name = node2.attributes['name'].value
        max_skill = node2.attributes['max'].value
        user_skill = node2.attributes['value'].value
        print ':', name.encode('iso-8859-1')
        guildie.professions.append(Professions(name, max_skill, user_skill))
    
    time.sleep(1)
    DBSession.add(guildie)
    
# Linghu, BloodElf GLA, Male, Hunter, Level 8, Guild Rank: Raider, Achievement Points: 4444
#linghu = Player('Linghu', 'BloodElf', 'GLA', 'Male', 'Hunter', 80, 6, 4444)  
#linghu.professions.append(Professions(6, 450, 450))
#linghu.professions.append(Professions(12, 450, 350))
#linghu.professions.append(Professions(7, 450, 350))
#DBSession.add(linghu)

# Contagion, BloodElf, GLA, Female, Paladin, Level 80, Guild Rank: GM, Achievement Points: 1000
#contagion = Player('Contagion', 'BloodElf', 'GLA', 'Female', 'Paladin', 80, 2, 1000)
#contagion.professions.append(Professions(5, 450, 450))
#contagion.professions.append(Professions(2, 450, 350))
#DBSession.add(contagion)

#DBSession.add_all([
#    Professions(1, 6, 450, 450),    # Linghu 450/450 Engineering
#    Professions(1, 12, 450, 350),    # Linghu 350/450 Mining
#    Professions(2, 5, 450, 450),    # Contagion 450/450 Enchanting
#    Professions(2, 2, 450, 350)     # Contagion 350/450 Alchemy
#])

# Save the page object to the in memory DBSession

DBSession.flush()

#loot = Loot(raid.raid_id, linghu.id, item.item_id, 'Icecrown', 'Trash mob', datetime.today(), 'This is a note')
#loot2 = Loot(raid2.raid_id, contagion.id, item2.item_id, 'Nexxus', 'Trash mob', datetime.today(), 'This is also a note')
#loot3 = Loot(raid.raid_id, linghu.id, item2.item_id, 'Dragonblight', 'Angry Wife', datetime.today(), '')
#loot4 = Loot(raid.raid_id, contagion.id, item2.item_id, 'Storms Peak', 'Windows Virus', datetime.today(), 'Silly Note')

#DBSession.add(loot)
#DBSession.add(loot2)
#DBSession.add(loot3)
#DBSession.add(loot4)

transaction.commit()
