# Copyright (C) 2009 Real Time Enterprises, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# http://www.wowwiki.com/API_GetItemInfo
# http://www.wowwiki.com/ItemString
class Item:
    def parseLUA(self, item):
        self.name = item['name']
        
        quality_hex = item['c']
        self.quality = self.__quality__[quality_hex]
        
        item_string = item['id']
        split = item_string.split(':')
        self.itemID = int(split[0])
        
        self.enchantID = int(split[1])
        self.j1 = int(split[2])
        self.j2 = int(split[3])
        self.j3 = int(split[4])
        self.j4 = int(split[5])
        self.suffixID = int(split[6])
        self.uniqueID = int(split[7])
        
    def getName(self):
        return self.name
       
    def getQuality(self):
        return self.quality
        
    def getItemID(self):
        return self.itemID

# http://www.wowwiki.com/API_ITEM_QUALITY_COLORS
# http://www.wowwiki.com/API_GetItemQualityColor
    __quality__ = {
        'ff9d9d9d' : 'Poor',
        'ffffffff' : 'Common',
        'ff1eff00' : 'Uncommon',
        'ff0070dd' : 'Rare', 
        'ffa335ee' : 'Epic', 
        'ffff8000' : 'Legendary', 
        'ffe6cc80' : 'Artifact',
        'ffe6cc80' : 'Heirloom'
    }

