# Copyright (C) 2009 Real Time Enterprises, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import lua
from item import Item
from loot import Loot

class Parser:
    """
    Parser for RaidTracker LUA files.
    """ 
    def open(self, datafile):
        dofile = 'dofile("' + datafile + '")'
        lua.execute(dofile)
        
    def parseLUA(self, root):
        self.eval(self,root)
        
    def eval(self, root):
        tables = lua.eval(root)
        return tables
    
    def getLoots(self, filter):
        logs = self.db['Log']
        item = Item()
        
        for log in logs:
            #print logs[log]['Loot']
            loots = logs[log]['Loot']
            for loot in loots:
                item.parseLUA(loots[loot]['item'])
                if item.quality == filter:
                    toon = loots[loot]['player']
                    time = loots[loot]['time']
                    note = loots[loot]['note']
                    yield Loot(toon, item, time, note)
                    
