# Copyright (C) 2009 Real Time Enterprises, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import lua
from nose.tools import raises, eq_, with_setup
from raidtracker.item import Item

class TestItem():

    def setup(self):
        lua.execute('dofile("tests/test-item.lua")')
        item = lua.eval('KARaidTrackerDB')
        for i in item:
            self.item = item[i]

    @raises(Exception)
    def testParseLUA0(self):
        item = Item()
        item.parseLUA(None)

    def testParseLUA1(self):
	    item = Item()
	    item.parseLUA(self.item)
	    eq_(item.getName(), 'Mantle of the Eternal Sentinel')
	    eq_(item.getQuality(), 'Epic')
	    eq_(item.getItemID(), 40439)

	    
