# Copyright (C) 2009 Real Time Enterprises, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from sets import Set
from nose.tools import raises, eq_, with_setup
from raidtracker.parser import Parser 

class TestParser():
    
    def setup(self):
        pass
    
    @raises(Exception)
    def testOpen0(self):
        t = Parser()
        t.open(None)
    
    @raises(Exception)
    def testOpen1(self):
        t = Parser()
        t.open('/etc/shadow')
        
    def testOpen2(self):
         t = Parser()
         t.open('tests/test-raidtracker.lua')
    
    @raises(Exception)     
    def testParseLUA0(self):
        t = Parser()
        t.parseLUA(None)
        
    def testParseLUA1(self):
        t = Parser()
        t.parseLUA('Blah')
        assert(t.db == None)
        
    def testParseLUA2(self):
        t = Parser()
        t.parseLUA('KARaidTrackerDB')
        assert(t.db != None)
        
    def testGetLoots0(self):
        t = Parser()
        t.open('tests/test-raidtracker.lua')
        t.parseLUA('KARaidTrackerDB')
        loots = t.getLoots('Common')
        assert(loots != None)
        
        item_set = Set(['Arcane Dust', 'Dream Dust', 'Illusion Dust'])
        for loot in loots:
            eq_(loot.toon, 'Gileon')
            assert(loot.item.name in item_set)