# Copyright (C) 2009 Real Time Enterprises, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

from sqlalchemy import *
from sqlalchemy.orm import mapper, relation
from sqlalchemy import Table, ForeignKey, Column
from sqlalchemy.types import Integer, Unicode, DateTime
#from sqlalchemy.orm import relation, backref
from raidtrackertg2.model import DeclarativeBase, metadata, DBSession
from raidtrackertg2.model import Item
from datetime import datetime

class Loot(DeclarativeBase):
    __tablename__ = 'loots'
    
    id = Column(Integer, primary_key=True)
    raid_id = Column(Integer, ForeignKey('raids.raid_id'))
    player_id = Column(Integer, ForeignKey('players.id'))
    item_id = Column(Integer, ForeignKey('items.item_id'))
    zone = Column(Unicode(255), nullable=False)
    boss = Column(Unicode(255), nullable=False)
    time = Column(DateTime, nullable=False)
    note = Column(Unicode(255), nullable=True)

    
    def __init__(self, raid_id, player_id, item_id, zone, boss, time, note):
        self.raid_id = raid_id
        self.player_id = player_id
        self.item_id = item_id
        self.zone = zone
        self.boss = boss
        self.time = time
        self.note = note
        
    @staticmethod
    def parse(index, logs, raid_id):
        loots = logs[index]['Loot']
        for index in loots:
            loot_id = loots[index]
            
            player_id = loot_id['player']
            
            item = Item.parse2(loot_id['item'])
            print 'aaaaaaa', item, item.item_id
            item_id = item.item_id
            
            zone = loot_id['zone']
            boss = loot_id['boss']
            time = datetime.fromtimestamp(loot_id['time'])
            note = loot_id['note']
            yield Loot(raid_id, player_id, item_id, zone, boss, time, note)