# Copyright (C) 2009 Real Time Enterprises, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

from sqlalchemy import *
from sqlalchemy.orm import mapper, relation
from sqlalchemy import Table, ForeignKey, Column
from sqlalchemy.types import Integer, Unicode
from sqlalchemy.orm import relation, backref
from raidtrackertg2.model import DeclarativeBase, metadata, DBSession
from datetime import datetime

class Professions(DeclarativeBase):
    __tablename__ = 'professions'

    id = Column(Integer, primary_key=True)
    player_id = Column(Integer, ForeignKey('players.id'))
    name = Column(Unicode(255), nullable=False)
    max_skill = Column(Integer)
    player_skill = Column(Integer)
    
    def __init__(self, name, max_skill, player_skill):
        self.name = name
        self.max_skill = max_skill
        self.player_skill = player_skill
        
    def __wtf__(self, profession):
        if profession == 'Unknown':
            return 1
        if profession == 'Alchemy':
            return 2
        if profession == 'Blacksmithing':
            return 3
        if profession == 'Cooking':
            return 4
        if profession == 'Enchanting':
            return 5
        if profession == 'Engineering':
            return 6
        if profession == 'First Aid':
            return 7
        if profession == 'Fishing':
            return 8
        if profession == 'Herbalism':
            return 9
        if profession == 'Jewelcrafting':
            return 10
        if profession == 'Leatherworking':
            return 11
        if profession == 'Mining':
            return 12
        if profession == 'Tailoring':
            return 13
        if profession == 'Skining':
            return 14
        if profession == 'Inscription':
            return 15