# Copyright (C) 2009 Real Time Enterprises, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

from sqlalchemy import *
from sqlalchemy.orm import mapper, relation
from sqlalchemy import Table, ForeignKey, Column
from sqlalchemy.types import Integer, Unicode, DateTime
#from sqlalchemy.orm import relation, backref
from raidtrackertg2.model import DeclarativeBase, metadata, DBSession
from datetime import datetime
from realtime.formatdatetime import formatAndConvertTime

class Raid(DeclarativeBase):
    __tablename__ = 'raids'
    
    id = Column(Integer, primary_key=True)
    raid_id = Column(Integer, unique=True)
    date_time = Column(DateTime)
    zone = Column(Unicode(255), nullable=False)
    difficulty = Column(Unicode(255), nullable=False)
    
    def __init__(self, raid_id, date_time, zone, difficulty):
        self.raid_id = raid_id
        self.date_time = date_time
        self.zone = zone
        self.difficulty = difficulty
        
    @staticmethod
    def parse(index, logs):
        raids = logs[index]
        raid_id = raids['iid']
        
        date_time = datetime.fromtimestamp(raids['key'])
        zone = raids['zone']
        difficulty = raids['idiff']
        
        return Raid(raid_id, date_time, zone, difficulty)
        