# Copyright (C) 2008 Real Time Enterprises, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import datetime

def formatAndConvertTime(time, timezone, fmt):  
	"""
	Return a datetime object formatted to a specific timezone and a user provided format.

	Parameters:

	- `time` - timestamp as a string
	- `timezone` - Olson database timezone name
	- `fmt` - datetime format string
	"""
	tz = time.astimezone(timezone)
	formatted = tz.strftime(fmt)
	return formatted
